现在的位置: 首页 > 综合 > 正文

Codeforces Round #283 (Div. 2) D. Tennis Game

2018年04月08日 ⁄ 综合 ⁄ 共 2959字 ⁄ 字号 评论关闭
标程貌似是二分?

我预处理标记了一下,然后从1到n枚举t,因为对于每个t,若s存在,那么s是唯一的,所以枚举t即可。

判断t是否合法,直接暴力的话,会超时

不知道标程大致思想是否跟我的一样,也许就是标程没有标记而是二分来找

但是,我的时间复杂度是更优的,n*(1+1/2+1/3+......1/n)=n*lnn的做法

#include<iostream>
#include<map>
#include<string>
#include<cstring>
#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<queue>
#include<vector>
#include<algorithm>
using namespace std;
struct Ans
{
	int s,t;
	Ans(){}
	Ans(int a,int b){s=a;t=b;}
	bool operator <(Ans x)const
	{
		return s!=x.s?s<x.s:t<x.t;
	}
};
vector<Ans>ans;
int in[100010];
int as[100010];
int ap[200010];
int bs[100010];
int bp[200010];
int n;
void maketable()
{
	int i,x,y;
	x=y=0;
	memset(ap,-1,sizeof(ap));
	memset(bp,-1,sizeof(bp));
	for(i=0;i<n;i++)
	{
		if(in[i]==1)
			ap[++x]=i;
		else
			bp[++y]=i;
		as[i]=x;
		bs[i]=y;
	}
}
int isok(int s)
{
	int t1,t2,x,y;
	t1=t2=s;
	x=y=0;
	while(1)
	{
		if(ap[t1]==-1&&bp[t2]==-1)
			return 0;
		if(ap[t1]==n-1&&bp[t2]==-1)
		{
			++x;
			return x<=y?0:x;
		}
		if(ap[t1]==-1&&bp[t2]==n-1)
		{
			++y;
			return y<=x?0:y;
		}
		if(bp[t2]==-1||(ap[t1]!=-1&&ap[t1]<bp[t2]))
		{
			t2=bs[ap[t1]]+s;
			t1+=s;
			x++;
		}
		else if(ap[t1]==-1||(bp[t2]!=-1&&ap[t1]>bp[t2]))
		{
			t1=as[bp[t2]]+s;
			t2+=s;
			y++;
		}
		else
			return 0;
	}
}
int main()
{
	int i,t,m;
	scanf("%d",&n);
	for(i=0;i<n;i++)
		scanf("%d",in+i);
	maketable();
	for(i=1;i<=n;i++)
	{
		t=isok(i);
		if(t!=0)
			ans.push_back(Ans(t,i));
	}
	sort(ans.begin(),ans.end());
	m=ans.size();
	printf("%d\n",m);
	for(i=0;i<m;i++)
		printf("%d %d\n",ans[i].s,ans[i].t);
}

D. Tennis Game

time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

Petya and Gena love playing table tennis. A single match is played according to the following rules: a match consists of multiple sets, each set consists of multiple serves. Each serve is won by one of the players, this player scores one point. As soon as
one of the players scores t points, he wins the set; then the next set starts and scores of both players are being set to 0. As soon as one of the players wins the total ofs sets,
he wins the match and the match is over. Heres and
t are some positive integer numbers.

To spice it up, Petya and Gena choose new numbers s andt before every match. Besides, for the sake of history they keep a record of each match: that is, for each serve they write
down the winner. Serve winners are recorded in the chronological order. In a record the set is over as soon as one of the players scores
t points and the match is over as soon as one of the players winss sets.

Petya and Gena have found a record of an old match. Unfortunately, the sequence of serves in the record isn't divided into sets and numberss and
t for the given match are also lost. The players now wonder what values ofs and
t might be. Can you determine all the possible options?

Input

The first line contains a single integer n — the length of the sequence of games (1 ≤ n ≤ 105).

The second line contains n space-separated integersai. Ifai = 1,
then thei-th serve was won by Petya, if
ai = 2
, then the
i
-th serve was won by Gena.

It is not guaranteed that at least one option for numberss and
t corresponds to the given record.

Output

In the first line print a single number k — the number of options for numberss and
t.

In each of the following k lines print two integerssi andti —
the option for numberss and
t
. Print the options in the order of increasingsi, and for equalsi — in the order of
increasingti.

Sample test(s)
Input
5
1 2 1 2 1
Output
2
1 3
3 1
Input
4
1 1 1 1
Output
3
1 4
2 2
4 1
Input
4
1 2 1 2
Output
0
Input
8
2 1 2 1 1 1 1 1
Output
3
1 6
2 3
6 1
【上篇】
【下篇】

抱歉!评论已关闭.